#include "..\..\include\orbitersdk.h"
#include "..\..\..\OrbiterSoundSDK\include\OrbiterSoundSDK35.h"
#include "Vessel2M.h"


const int SND_INTL = 1;
const int SND_PYRO = 2;
const int SND_CLANG = 3;

//+++
class Luna10ALS: public VESSEL2M {
public:
	// constructor
	Luna10ALS (OBJHANDLE hObj, int fmodel);

	// callbacks
	void clbkSetClassCaps(FILEHANDLE cfg);
	bool clbkLoadGenericCockpit ();
	void clbkPostStep(double simt, double simdt, double mjd);
	void clbkPostCreation (void);
    int clbkConsumeBufferedKey(DWORD key, bool down, char *kstate);

	// VESSEL2M overrides
	void clbkSaveState (FILEHANDLE scn);
	void ParseScenarioLineEx(char *line, void *status);
    void GetVesselMessage(VesselMessage VM);
	void FinishConfiguration();

private:


	// animations
	bool bAnimate;				//+--
	bool bPlayClang;			//+--
	double AnimationPercent;	//+++
	UINT Animation;				//---
	double Simdt;				//---
	double Timer;				//+++
	void DefineAnimations();
	void Animate();

	// sound
	int SoundLibID;
};
