#include "..\..\include\orbitersdk.h"
#include "Vessel2M.h"


const double INFLATION_SPEED = 1.0;
const double DEFLATION_SPEED = 0.05;
const double Z_FLATENED = 0.05;
const double Z_INFLATED = 0.45;
const double Z_ORIGINAL = 0.4;


class Luna9AB: public VESSEL2M {
public:
	// constructor
	Luna9AB (OBJHANDLE hObj, int fmodel);

	// callbacks
	void clbkSetClassCaps(FILEHANDLE cfg);
	void clbkPostStep(double simt, double simdt, double mjd);

	// VESSEL2M overrides
	void clbkSaveState (FILEHANDLE scn);
	void ParseScenarioLineEx(char *line, void *status);
    void GetVesselMessage(VesselMessage VM);
	void FinishConfiguration();

private:
	// runtime
	double Simdt;				//---

	// configuration
	void UpdatePhysics();

	// animations
	bool bAnimate;				//+--
	enum anim_type { SPHERIC, FLAT } CurrentAnimType; //+++
    enum anim_status { INITIAL, FINAL } SphericStatus, FlatStatus, CurrentAnimStatus; //+++
	UINT SphericAnimation, FlatAnimation, CurrentAnimation; //+++
	double AnimationPercent;	//+++
	double AnimSpeed;			//+++
	double dZTouch;				//+++
	void DefineAnimations(); 
	void Animate();
	void FastForwardAnimation(anim_type AnimType, double AnimPercent = 1);
	void AnimationStart(anim_type AnimType);
	void AnimationEnd(anim_type AnimType, anim_status NewStatus);
};
