#include "..\..\include\orbitersdk.h"


const int MSH_WRECK_CRATER = 0;
const int MSH_WRECK_KTDU   = 1;
const int MSH_WRECK_ALS    = 2;

// sounds
const int SND_CRASH = 1;


class Luna9Wreck:public VESSEL2
{
public:
	// common class operations
	Luna9Wreck (OBJHANDLE hObj, int fmodel);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep(double simt, double simdt, double mjd);
	void clbkVisualCreated (VISHANDLE vis,int refcount);
	void clbkPostCreation (void);

	enum blastState {NONE, TOBLAST, BLASTING, TOSMOKE, SMOKING, TODUST, DUSTING} 
		BlastState;					//+++ + blast and smoke - visual imitation
	bool bJustDeployed;				//+-- + a flag for runtime creation
	int bFocus;						//+++ +
	bool bLoadMesh;					//+++ +
	int WreckMeshID;				//+++ +
	bool bFlying;					//+//


private:

	void FinishConfiguration();


	// bright blast imitation
	double StopBlastTime; //---
	double BlastLevel; //---
	void StartBlast();
	void StopBlast();

	// smoking marker
	double SmokeLevel; //---
	void StartSmoke();

	// dust cloud
	double DustLevel; //---
	double StopDustTime;
	void StartDust();
	void StopDust();

	// land/air
	void Land();

	// sound
	int SoundLibID;//---

	// mesh, need it to kill shadows
	VISHANDLE VisHandle;
	MESHHANDLE hCraterMesh;
	void HideShadows();
};
