#include "..\..\include\orbitersdk.h"

#pragma warning(disable:4996)   // disable CRT string functions security warnings

const bool TOPARENT = true; //default
const bool TOCHILD = false;
const bool LOOSE = true; // deafult 
const bool NOTLOOSE = false; 

const bool EXPLODE = true;
const bool NO_EXPLODE = false;
const bool GENERIC_CRATER = true;

// mesh IDs for different type of objects
const int MSH_WRECK_CRATER_V2M = 0;
const int MSH_WRECK_KTDU_V2M   = 1;
const int MSH_WRECK_ALS_V2M    = 2;



//+++
class VESSEL2M: public VESSEL2 {
public:
	// constructor
	VESSEL2M (OBJHANDLE hObj, int fmodel);

	// sending messages between VESSEL2M objects
	enum VesselMessage {VM_DETACH, VM_SEPARATE_CHILD, VM_INFLATE, VM_CASCADE_FOCUS_ENABLE, VM_TIMER};
	void SendVesselMessage(OBJHANDLE hTarget, VesselMessage VM);
	void SendVesselMessage(char* VesselName, VesselMessage VM);
    virtual void GetVesselMessage(VesselMessage VM);

	// structural speed and Q limits
	double VvCrash;		//+--
	double VhCrash;		//+--
	double VMaxBlast;	//+--
	double QMax;		//+--

	// configuration
	bool bAttached;		//+--
	bool bLandedPermanently;	//+--
	virtual void clbkSaveState (FILEHANDLE scn);
	void clbkLoadStateEx (FILEHANDLE scn, void *status);
	virtual void ParseScenarioLineEx(char *line, void *status);
	virtual void FinishConfiguration();

//	bool Attached();
	void TimestepForVESSEL2M();
	virtual void Land();

	// focus
	int bFocus;			//+++
	bool bFocusOffByDefault;	//+--   fosus is off bu default, except for KTDU, which will override this variable

	// what type of crater do we produce? :-)
	int WreckMeshID;	//+--
	
	// service functions
	double DRand(double from, double span);

private:
	// landing velocities, initialized in GetLandingVelocities(), used by other functions
	double V;	//---
	double Vv;	//---
	double Vh;	//---

	// landing-crashing-burning
	void GetLandingVelocities();
    bool bFuelExplode();
	void Explode(bool bGenericCrater = FALSE);
	void Crash();
	void Burn();
	void ReplaceWithWreck(bool bExplode = TRUE, bool bGenericCrater = FALSE);

	// dust
	PARTICLESTREAMSPEC Dust;	//+--
	bool bGeneratingDust;		//+--
	double DustTimer;			//+--
	double DustLevel;			//+--
	void StartDust();
	void StopDust();

};
